<!---
<fusedoc name="qryGetPollResults.cfm" language="ColdFusion" version="2.0">
  <responsibilities>
    I return a recordset of the specified poll question and its results
  </responsibilities>
  <properties>
    <history author="Stan Cox" email="stan@grokfusebox.com" role="architect" date="3/11/2004" />
  </properties>
  <io>
    <in>
      <number name="pollID" precision="integer" />
  </in>
    <out>
      <number name="respondents" scope="attributes" />
      <recordset name="qryGetPollResults">
        <number name="pollID" precision="integer" />
        <string name="pollQuestion" />
        <number name="agreePercentage" precision="integer" comments="rounded to nearest integer" />
        <number name="disagreePercentage" precision="integer" comments="rounded to nearest integer" />
      </recordset>
    </out>
  </io>
</fusedoc>
--->

<cfquery name="qryGetPollQuestion" datasource="#request.dsn#" dbtype="#request.dbt#">
  SELECT pollQuestion
    FROM pollQuestions
   WHERE pollID = #attributes.pollID#
</cfquery>

<cfquery name="qryGetPollOpinionCount" datasource="#request.dsn#" dbtype="#request.dbt#">
  SELECT pollOpinions.pollID,
         pollQuestion,
         Count(opinion) totalCount
    FROM pollOpinions,
         pollQuestions
   WHERE pollOpinions.pollID = pollQuestions.pollID
     AND pollOpinions.pollID = #attributes.pollID#
GROUP BY pollOpinions.pollID, 
         pollQuestion
</cfquery>

<cfquery name="qryGetPollOpinions"  datasource="#request.dsn#" dbtype="#request.dbt#">
  SELECT opinion
    FROM pollOpinions
   WHERE pollID = #attributes.pollID#
</cfquery>

<cfset variables.agreeCount = 0>
<cfset variables.disagreeCount = 0>
<cfset variables.agreePercentage = 0>
<cfset variables.disagreePercentage = 0>

<cfloop query = "qryGetPollOpinions">
  <cfif qryGetPollOpinions.opinion EQ "Yes">
    <cfset variables.agreeCount = variables.agreeCount + 1>
  <cfelse>
    <cfset variables.disagreeCount = variables.disagreeCount + 1>
  </cfif>
</cfloop>

<cfset attributes.respondents = qryGetPollOpinions.RecordCount>

<cfif qryGetPollOpinions.RecordCount>
  <cfif variables.agreeCount>
    <cfset variables.agreePercentage = (variables.agreeCount/qryGetPollOpinions.RecordCount)*100>
  </cfif>
  <cfif variables.disagreeCount>
    <cfset variables.disagreePercentage = (variables.disagreeCount/qryGetPollOpinions.RecordCount)*100>
  </cfif>
</cfif>

<cfoutput>
<cf_querysim>
qryGetPollResults
pollID,pollQuestion,agreePercentage,disagreePercentage
#attributes.pollID#|#qryGetPollQuestion.pollQuestion#|#variables.agreePercentage#|#variables.disagreePercentage#
</cf_querysim>
</cfoutput>
