<!-- FuseMinderPlus.cfm by jeff.peters@bigfoot.com -->
<!--- -->
<fusedoc fuse="FuseminderFB4.cfm" language="ColdFusion" specification="2.0">
  <responsibilities>
    I read a text outline file and generate the specified Fusebox3-compliant framework, including fuseboxes and fusestubs.  If "attributes.location" is not defined, I use the current directory as home.  If "attributes.verbose" is TRUE or not defined, I produce progress statements while working.  If "attributes.indenter" is not defined, I use two spaces ("	") as the outline indenting string.  If "attributes.mapper" is not defined, I use "". 
  </responsibilities>
  <properties>
    <history author="jeff@grokfusebox.com" date="17 Aug 2001" type="Create">
    <history author="jeff@grokfusebox.com" date="31 Jan 2003" type="update">
      Added handler for fuseQ nodes.
    </history>
	 <history author="jamie.thomas@integic.com" date="15 Mar 2004" type="update">
	 	Modified for Fusebox 4 usage
	 </history>
	 <history author="jeff@grokfusebox.com" date="17 Sep 2004" type="update">
	   Fixed to ignore colons in fusestub code.
	 </history>
  </properties>
  <io>
    <in>
      <string name="outlineFile" scope="attributes" optional="No">
      <string name="location" scope="attributes" default="GetDirectoryFromPath(GetCurrentTemplatePath())">
      <boolean name="verbose" scope="attributes" default="FALSE">
		<boolean name="writeFusedocs" scope="attributes" default="TRUE">
		<boolean name="writeFileName" scope="attributes" default="TRUE">
		<boolean name="writeXFALinks" scope="attributes" default="TRUE">
      <string name="indenter" scope="attributes" default="	">
      <string name="mapper" scope="attributes" default="">
    </in>
  </io>
</fusedoc>
--->

<style type="text/css">
body {
 font-family: Verdana, Helvetica, sans-serif;
 font-size: 9pt;
}
.header {
 font-family: Verdana, Helvetica, sans-serif;
 font-size: 10pt;
 font-weight: bold;
}
.bg0 { background: #FFAAAA }
.bg1 { background: #AAFFAA }
.bg2 { background: #AAAAFF }
.bg3 { background: #FFFFAA }
.bg4 { background: #AAFFFF }
.bg5 { background: #FFAAFF }
</style>

<!--- default parameters --->

<cfparam name="attributes.author" default="Unknown Developer">
<cfparam name="attributes.authorEmail" default="unknown.developer@mail.com">
<cfparam name="attributes.writeFusedocs" default="true">
<cfparam name="attributes.writeFileName" default="true">
<cfparam name="attributes.writeXFALinks" default="true">

<cfparam name="attributes.OutlineFile" default="unknown_file.txt">
<cfparam name="attributes.verbose" default="True">
<cfparam name="attributes.location" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#">
<cfparam name="attributes.core_file_location" default="#GetDirectoryFromPath(GetCurrentTemplatePath())#core_files\">
<cfparam name="attributes.indenter" default="#chr(9)#">
<cfparam name="attributes.mapper" default="">
<cfparam name="attributes.defaultFuseaction" default="home.main">

<!--- error variables --->

<cfparam name="variables.build_error_count" default="0">
<cfparam name="variables.write_error_count" default="0">

<!--- other variables --->
<cfset lstKnownLineTypes = "ct,cv,cva,cvo,defaultFa,df,do,fa,ff,globalPostfa,globalPrefa,ict,ifa,pct,pfa,postfa,prefa,xfa">

<!--- function to do a cfdump from within CFSCRIPT

*********** REQUIRES CFMX *************

<cffunction name="scriptDump" returntype="any">
	<cfargument name="thingToDump" required="yes" default="No Argument Passed To scriptDump()" type="any">
	<cfdump var="#thingToDump#">
</cffunction>

 --->

<cfscript>
function fuseStubCreate(myFileName,myXFAList,myCVList,writeFusedoc,writeFileName,writeXFALinks) {

	var strReturn = "";
	var crlf = chr(10);
	var strAuthor = attributes.author;
	var strEmail = attributes.authorEmail;
	var strResponsibilities = "";
	var strPassthrough = "";
	var strIn = "";
	var strOut = "";
	
	if (left(myFileName,3) eq "qry") {
		strResponsibilities = "I return a recordset.";
		strPassthrough = "			<string name=""request.application.database.dsn"" optional=""No"" />" & crlf;
		strOut = strOut & "			<recordset name=""" & listFirst(myFileName,".") & """ optional=""No"" primarykeys="""" scope=""variables"" format=""CFML"">" & crlf;
		strOut = strOut &  "			</recordset>" & crlf;
		}
	else
		strResponsibilities = "I do something.";

	if (writeFusedoc eq true) {
		strReturn = "<!--- -->" & crlf;
		strReturn = strReturn & "<fusedoc fuse=""" & myFileName & """ language=""ColdFusion"" specification=""2.0"">" & crlf;
		strReturn = strReturn & "	<responsibilities>" & crlf;
		strReturn = strReturn & "		" & strResponsibilities & crlf;
		strReturn = strReturn & "	</responsibilities>" & crlf;
		strReturn = strReturn & "	<properties>" & crlf;
		strReturn = strReturn & "		<history author=""" & strAuthor & """ date=""" & dateFormat(now(),"mm/dd/yyyy") & """ email=""" & strEmail & """ role=""Architect"" type=""Create"" />" & crlf;
		strReturn = strReturn & "	</properties>" & crlf;
		strReturn = strReturn & "	<io>" & crlf;
		if (trim(strPassthrough) neq "") {
			strReturn = strReturn & "		<passthrough>" & crlf;
			strReturn = strReturn & strPassthrough;
			strReturn = strReturn & "		</passthrough>" & crlf;
		}
		strReturn = strReturn & "		<in>" & crlf;
		strReturn = strReturn & strIn;
		if (listLen(myXFAList) neq 0) {
			strReturn = strReturn & '			<structure name="xfa" format="CFML" scope="variables" comments="list of xfas to use">' & crlf;
				for(i=1; i LTE listLen(myXFAList); i = i + 1)
				strReturn = strReturn & '				<string name="' & listGetAt(myXFAList,i) & '" optional="No" format="CFML" />' & crlf;
			strReturn = strReturn & '			</structure>' & crlf;
		}
		if (listLen(myCVList) neq 0) {
			for(i=1; i LTE listLen(myCVList); i = i + 1)
				strReturn = strReturn & '			<string name="' & listGetAt(myCVList,i) & '" optional="No" format="CFML" />' & crlf;
		}		
		strReturn = strReturn & "		</in>" & crlf;
		strReturn = strReturn & "		<out>" & crlf;
		strReturn = strReturn & strOut;	
		strReturn = strReturn & "		</out>" & crlf;
		strReturn = strReturn & "	</io>" & crlf;
		strReturn = strReturn & "</fusedoc>" & crlf;
	 	strReturn = strReturn & "--->" & crlf;
	}
	
	if (writeFileName eq true)
		strReturn = strReturn & "<b>" & myFileName & "</b><br>" & crlf;
	
	if (listLen(myXFAList) neq 0 and writeXFALinks) {
		strReturn = strReturn & "<br><i><b>" & myFileName & " XFAs</b></i><br>" & crlf;
			for(i=1; i LTE listLen(myXFAList); i = i + 1)
			strReturn = strReturn & '<cfif isDefined("xfa.#listGetAt(myXfaList,i)#")><a href="index.cfm?fuseaction=<cfoutput>##xfa.' & listGetAt(myXfaList,i) & '##</cfoutput>">xfa.' & listGetAt(myXfaList,i) & '</a><cfelse>''xfa.#listGetAt(myXfaList,i)#'' not defined for this fuseaction</cfif><br>' & crlf;		
		strReturn = strReturn & "<br>";
	}
	
	// Output content variables
	if (listLen(myCVList) neq 0) {
		strReturn = strReturn & "<br><i><b>" & myFileName & " Content Variables</b></i><br>" & crlf;
			for(i=1; i LTE listLen(myCVList); i = i + 1)
			strReturn = strReturn & '<cfif isDefined("#listGetAt(myCVList,i)#")><table border="1"><tr><td><b>#listGetAt(myCVList,i)#</b><hr><cfoutput>##' & listGetAt(myCVList,i) & '##</cfoutput></td></tr></table><cfelse>content variable ''#listGetAt(myCVList,i)#'' not defined for this fuseaction</cfif><br>' & crlf;		
		strReturn = strReturn & "<br>";
	}
	
	// stub out query tags for query files
	if (left(myFileName,3) eq "qry") {
		strReturn = strReturn & crlf;
		strReturn = strReturn & "<!---" & crlf & "<cf_querysim>" & crlf;
		strReturn = strReturn & listFirst(myFileName,".")  & crlf;
		strReturn = strReturn & "</cf_querysim>" & crlf & "--->";	
		
		strReturn = strReturn & crlf & crlf;
		strReturn = strReturn & "<!---" & crlf & "<cfquery name=""" & listFirst(myFileName,".") & """ datasource=""##request.application.database.dsn##"">" & crlf;
		strReturn = strReturn & "</cfquery>" & crlf & "--->";
		
		strReturn = strReturn & crlf & crlf;
		strReturn = strReturn & "<!---" & crlf & "<cfdump var=""##" & listFirst(myFileName,".") & "##"">" & crlf & "--->";
		}
		
	return strReturn;
}

function xfaLookup( stuCircuit, strFuseaction, strFuse )
{
	var strCircuit = stuCircuit.name;
	var strCompoundFuseaction = strCircuit & "." & strFuseaction;
	var strXFAList = "";
	var i = 0;
	var bReturn = false;
	
	for (keyName in stuFuseboxes) 
	{
    if (structKeyExists(stuFuseboxes[keyName].dos, strCompoundFuseaction) eq true)
	 	{
	 	strXFAList = stuFuseboxes[keyName].dos[strCompoundFuseaction].XFAList;
		if ( strXFAList neq "" )
			{
			for (i = 1; i lte listLen(strXFAList); i = i + 1)
				{
					// append to fuses xfa to both structures
					if (listFindNoCase(stuCircuit.fuses[strFuse].xfaList,listGetAt(strXFAList,i)) eq 0)
						{
						stuCircuit.fuses[strFuse].xfaList = listAppend(stuCircuit.fuses[strFuse].xfaList, listGetAt(strXFAList,i));
						stuFuseboxes[strCircuit].fuses[strFuse].xfaList = listAppend(stuFuseboxes[strCircuit].fuses[strFuse].xfaList, listGetAt(strXFAList,i));
						bReturn = true;
						}
				}
			}
		}
	} 
	
	return bReturn;
}
</cfscript>

<!--- Create array to track which circuit we're in according to line's depth. --->
<cfset aryInCircuit = ArrayNew(1)>

<!--- check for outline file --->
<cfif IsDefined("attributes.OutlineFile") EQ "No">
  <cfthrow type="FuseMinderPlusError" message="OutlineFile not specified.">
</cfif>

<cfset circuitPath = "">
<cfset lastCircuitPath = "">
<cfset lastCircuitDepth = 0>

<!--- If attributes.location has a colon in it, we're in Windows, else Unix --->
<cfif Find(":",attributes.location) GT 0>
  <cfset slash = "\">
  <cfset Crlf = Chr(10)>
<cfelse>
  <cfset slash = "/">
  <cfset Crlf = Chr(13)>
</cfif>

<cfset lastCircuit = "">
<cfset lastFuseaction = "">
<cfset modeEverybodyReadWrite = 666>

<!--- Fusebox file string constants --->
<cfscript>
fbOpenXMLLines = "<!-- Auto-generated by FuseminderFB4 for #attributes.author# (#attributes.authorEmail#) #dateFormat(now())# #timeFormat(now())# -->#crlf#";
fbOpenFuseboxXML = "<?xml version=""1.0"" encoding=""UTF-8""?>
#fbOpenXMLLines#
<fusebox>";

function fbOpenCircuitXML( stu )
{
	var strReturn = "#fbOpenXMLLines#<circuit access=""#stu.access#"">";
	var i = 0;
	var j = 0;
	
	strReturn = strReturn & "
	<prefuseaction>
	";
	
	if (listLen(stu.preFuseactionList) neq 0)
	{
		for (i=1;i lte listLen(stu.preFuseactionList);i=i+1)
		{
			if (listLen(stu.preFuseactions[listGetAt(stu.preFuseactionList,i)].xfaList) neq 0)
			{
				for(j=1;j lte listLen(stu.preFuseactions[listGetAt(stu.preFuseactionList,i)].xfaList);j=j+1)
				{
					iXFA = listGetAt(stu.preFuseactions[listGetAt(stu.preFuseactionList,i)].xfaList,j);
					strReturn = strReturn & "	<xfa name=""#listFirst(iXFA,"=")#"" value= ""#ListLast(iXFA,"=")#"" />#crlf#";
				}
			}

			if (stuCircuit.preFuseactions[listGetAt(stu.preFuseactionList,i)].contentVariable neq "")
				{
				if (stuCircuit.preFuseactions[listGetAt(stu.preFuseactionList,i)].contentVariableAppendAttribute neq "")
					strReturn = strReturn & "	<do action=""#listGetAt(stu.preFuseactionList,i)#"" contentvariable=""#stuCircuit.preFuseactions[listGetAt(stu.preFuseactionList,i)].contentVariable#"" append=""#stuCircuit.preFuseactions[listGetAt(stu.preFuseactionList,i)].contentVariableAppendAttribute#"" />
	";
				else
					strReturn = strReturn & "	<do action=""#listGetAt(stu.preFuseactionList,i)#"" contentvariable=""#stuCircuit.preFuseactions[listGetAt(stu.preFuseactionList,i)].contentVariable#"" />
	";				
				}
			else
				strReturn = strReturn & "	<do action=""#listGetAt(stu.preFuseactionList,i)#"" />
	";
		}
	}
	
	strReturn = strReturn & "</prefuseaction>";

	return strReturn;
}

function fbCloseCircuitXML( stu )
{
	var strReturn = "	
	<postfuseaction>
	";
	var j = 0;
	var iXFA = "";

	if (listLen(stu.postFuseactionList) neq 0)
	{
		for (i=1;i lte listLen(stu.postFuseactionList);i=i+1)
		{
			if (listLen(stu.postFuseactions[listGetAt(stu.postFuseactionList,i)].xfaList) neq 0)
			{
				for(j=1;j lte listLen(stu.postFuseactions[listGetAt(stu.postFuseactionList,i)].xfaList);j=j+1)
				{
					iXFA = listGetAt(stu.postFuseactions[listGetAt(stu.postFuseactionList,i)].xfaList,j);
					strReturn = strReturn & "	<xfa name=""#listFirst(iXFA,"=")#"" value= ""#ListLast(iXFA,"=")#"" />#crlf#";
				}
			}
			
			if (stuCircuit.postFuseactions[listGetAt(stu.postFuseactionList,i)].contentVariable neq "")
				{
				if (stuCircuit.postFuseactions[listGetAt(stu.postFuseactionList,i)].contentVariableAppendAttribute neq "")
					strReturn = strReturn & "	<do action=""#listGetAt(stu.postFuseactionList,i)#"" contentvariable=""#stuCircuit.postFuseactions[listGetAt(stu.postFuseactionList,i)].contentVariable#"" append=""#stuCircuit.postFuseactions[listGetAt(stu.postFuseactionList,i)].contentVariableAppendAttribute#"" />
	";
				else
					strReturn = strReturn & "	<do action=""#listGetAt(stu.postFuseactionList,i)#"" contentvariable=""#stuCircuit.postFuseactions[listGetAt(stu.postFuseactionList,i)].contentVariable#"" />
	";
				}
			else
				strReturn = strReturn & "	<do action=""#listGetAt(stu.postFuseactionList,i)#"" />
	";
		}
	}
	
	strReturn = strReturn & "</postfuseaction>
</circuit>";
	return strReturn;
}

function fbCloseFuseboxXML( stu )
{
	var strReturn = "";
	var i = 0;
	var j = 0;

	strReturn = "	<parameters>
		<parameter name=""fuseactionVariable"" value=""fuseaction"" />
		<parameter name=""defaultFuseaction"" value=""#attributes.defaultFuseaction#"" />
		<parameter name=""precedenceFormOrUrl"" value=""form"" />
		<parameter name=""mode"" value=""development"" />
		<parameter name=""password"" value="""" />
		<parameter name=""parseWithComments"" value=""true"" />
		<parameter name=""scriptlanguage"" value=""cfmx"" />
		<parameter name=""scriptFileDelimiter"" value=""cfm""/>
		<parameter name=""maskedFileDelimiters"" value=""htm,cfm,cfml,php,php4,asp,aspx"" />
		<parameter name=""characterEncoding"" value=""utf-8"" />
	</parameters>

	<globalfuseactions>
		<preprocess>#crlf#";

	if (listLen(stu.globalPreFuseactionList) neq 0)	
	{
		for (i=1;i lte listLen(stu.globalPreFuseactionList);i=i+1)
		{
			for(j=1;j lte listLen(stu.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].xfaList);j=j+1)
			{
				iXFA = listGetAt(stu.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].xfaList,j);
				strReturn = strReturn & "			<xfa name=""#listFirst(iXFA,"=")#"" value= ""#ListLast(iXFA,"=")#"" />#crlf#";
			}

			if (stuCircuit.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].contentVariable neq "")
				{
				if (stuCircuit.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].contentVariableAppendAttribute neq "")
					strReturn = strReturn & "			<do action=""#listGetAt(stu.globalPreFuseactionList,i)#"" contentvariable=""#stuCircuit.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].contentVariable#"" append=""#stuCircuit.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].contentVariableAppendAttribute#"" />
	";
				else
					strReturn = strReturn & "			<do action=""#listGetAt(stu.globalPreFuseactionList,i)#"" contentvariable=""#stuCircuit.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].contentVariable#"" />
	";				
				}
			else
				strReturn = strReturn & "			<do action=""#listGetAt(stu.globalPreFuseactionList,i)#"" />
	";
		}
	}
		
	strReturn = strReturn & "	</preprocess>
		<postprocess>#crlf#";

	if (listLen(stu.globalPostFuseactionList) neq 0)	
	{
		for (i=1;i lte listLen(stu.globalPostFuseactionList);i=i+1)
		{
			for(j=1;j lte listLen(stu.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].xfaList);j=j+1)
			{
				iXFA = listGetAt(stu.globalPreFuseactions[listGetAt(stu.globalPreFuseactionList,i)].xfaList,j);
				strReturn = strReturn & "			<xfa name=""#listFirst(iXFA,"=")#"" value= ""#ListLast(iXFA,"=")#"" />#crlf#";
			}

			if (stuCircuit.globalPostFuseactions[listGetAt(stu.globalPostFuseactionList,i)].contentVariable neq "")
				{
				if (stuCircuit.globalPostFuseactions[listGetAt(stu.globalPostFuseactionList,i)].contentVariableAppendAttribute neq "")
					strReturn = strReturn & "			<do action=""#listGetAt(stu.globalPostFuseactionList,i)#"" contentvariable=""#stuCircuit.globalPostFuseactions[listGetAt(stu.globalPostFuseactionList,i)].contentVariable#"" append=""#stuCircuit.globalPostFuseactions[listGetAt(stu.globalPostFuseactionList,i)].contentVariableAppendAttribute#"" />
	";
				else
					strReturn = strReturn & "			<do action=""#listGetAt(stu.globalPostFuseactionList,i)#"" contentvariable=""#stuCircuit.globalPostFuseactions[listGetAt(stu.globalPostFuseactionList,i)].contentVariable#"" />
	";				
				}
			else
				strReturn = strReturn & "			<do action=""#listGetAt(stu.globalPostFuseactionList,i)#"">
	";
		}
	}		

	strReturn = strReturn & "	</postprocess>
	</globalfuseactions>
	
	<plugins>
		<phase name=""preProcess"">
		</phase>
		<phase name=""preFuseaction"">
		</phase>
		<phase name=""postFuseaction"">	
		</phase>
		<phase name=""fuseactionException"">
		</phase>		
		<phase name=""postProcess"">
		</phase>
		<phase name=""processError"">
		</phase>
	</plugins>
</fusebox>";

	return strReturn;
}

</cfscript>

<!--- Create a structure to hold circuit information --->
<cfset stuFuseboxes = StructNew()>
<cfset circuitList = "">

<!--- Read in outline file --->
<cftry>
  <cffile action="read" variable="strRawInput" file="#attributes.location##attributes.OutlineFile#">
  <cfcatch>
    <cfoutput>
    Error: Outline file #attributes.location##attributes.OutlineFile# does not exist.
    </cfoutput>
    <cfabort>
  </cfcatch>
</cftry>
<cfset aryOutline = ListToArray(strRawInput,crlf)>

<!--- For each line in outline: --->
<cftry> 
<cfloop from="1" to="#ArrayLen(aryOutline)#" index="lineNum">
  <cfif (attributes.mapper EQ "MM") and (lineNum GT 1)>
    <cfset aryOutline[lineNum] = attributes.indenter & aryOutline[lineNum]>
  </cfif>

  <cfset trimmedLine = Trim(Replace(aryOutline[lineNum], "#attributes.indenter#", "","ALL"))>
  <cfif Len(trimmedLine) GT 0>
    <!--- Take action based on node identifier --->
	<cfif findNoCase(":",trimmedLine) neq 0>
	   <cfset lineType = listFirst(trimmedLine,":")>
	   <cfif ListFind(lstKnownLineTypes,lineType) eq 0>
	     <cfset lineType = "">
	   </cfif>
	<cfelse>
		<cfset lineType = "">
	</cfif>
  	<cfswitch expression = "#lineType#">
      <!--- ************************************************************* --->
      <!---  Process a circuit node                                       --->
      <!--- ************************************************************* --->
      <cfcase value="ct,pct,ict">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <!--- Get circuit name, and alias if present --->
        <cfset circuitName = Trim(ListLast(aryOutline[lineNum],":"))>
		  
        <cfif FindNoCase("(",circuitName)>
          <cfset circuitAlias = listFirst(ListLast(circuitName,"("),")")>
          <cfset circuitName = Trim(listFirst(circuitName,"("))>
        <cfelse>
          <cfset circuitAlias = circuitName>
        </cfif>
		  
		  <!--- append circuit to circuit list --->
		  <cfset circuitList = listAppend(circuitList,circuitName)>
		  
        <!--- determine depth --->
        <cfset circuitDepth = lineDepth>
        
        <!--- Put circuit's alias in the array slot for its level --->
        <cfset aryInCircuit[circuitDepth] = circuitName>
			
        <!--- Determine circuit's path based on depth relationship to previous circuit. --->
        <cfif circuitDepth GT lastCircuitDepth>
     		  <cfset circuitPath="#lastCircuitPath##circuitName##slash#">
        <cfelse>
          <!--- Pop one circuit off lastCircuitPath to get the parent, then add this circuit. --->
          <cfset circuitPath = "">
          <cfloop from="1" to="#Evaluate(circuitDepth-1)#" index="i">
            <cfset circuitPath = circuitPath & slash & ListGetAt(lastCircuitPath,i,slash)>
          </cfloop>
          <cfset circuitPath = "#circuitPath##slash##circuitName##slash#">
        </cfif>
        
        <!--- Add a structure to stuFuseboxes for this circuit --->
        <cfset stuFuseboxes[circuitName] = structNew()>
		  <cfset stuFuseboxes[circuitName].alias = circuitAlias>
		  <cfset stuFuseboxes[circuitName].name = circuitName>
        <cfset stuFuseboxes[circuitName].path = circuitPath>
        <cfset stuFuseboxes[circuitName].depth = circuitDepth>
		  <cfset stuFuseboxes[circuitName].directFiles = structNew()>		  
		  <cfset stuFuseboxes[circuitName].directFiles.fuseList = "">
		  <cfset stuFuseboxes[circuitName].layouts = structNew()>
		  <cfset stuFuseboxes[circuitName].layouts.fuseList = "">
		  <cfset stuFuseboxes[circuitName].layouts.xfaList = "">
		  <cfset stuFuseboxes[circuitName].fuseactions = structNew()>
		  <cfset stuFuseboxes[circuitName].fuseactionList = "">
		  <cfset stuFuseboxes[circuitName].fuses = structNew()>
		  <cfset stuFuseboxes[circuitName].dos = structNew()>
		  <cfset stuFuseboxes[circuitName].preFuseactionList = "">
		  <cfset stuFuseboxes[circuitName].preFuseactions = structNew()>
		  <cfset stuFuseboxes[circuitName].postFuseactionList = "">
		  <cfset stuFuseboxes[circuitName].postFuseactions = structNew()>
		  <!--- setup global containers --->
		  <cfif circuitName eq listFirst(structKeyList(stuFuseboxes))>
			  <cfset stuFuseboxes[circuitName].globalPreFuseactionList = "">
			  <cfset stuFuseboxes[circuitName].globalPreFuseactions = structNew()>
			  <cfset stuFuseboxes[circuitName].globalPostFuseactionList = "">
			  <cfset stuFuseboxes[circuitName].globalPostFuseactions = structNew()>		  
		  </cfif>

		  <!--- if pct, set access to private --->
		  <cfif lineType eq "pct">
			  <cfset stuFuseboxes[circuitName].access = "private">
		  <cfelseif lineType eq "ict">
			  <cfset stuFuseboxes[circuitName].access = "internal">
		  <cfelse>
			  <cfset stuFuseboxes[circuitName].access = "public">
		  </cfif>
        
        <!--- Set parent circuit path as one level above circuit path --->
        <cfset parentPath = "">
        <cfif ListLen(circuitPath,slash) GT 1>
          <cfloop from="1" to="#Evaluate(circuitDepth)#" index="i">
            <cfif Len(parentPath)>
              <cfset tempDelim = slash>
            <cfelse>
              <cfset tempDelim = "">
            </cfif>
            <cfset parentPath = parentPath & tempDelim & ListGetAt(circuitPath,i,slash)>
          </cfloop>
        </cfif>
        <cfset parentAlias = "#ListLast(parentPath,slash)#">
        <cfset parentPath = "#parentPath##slash#">
  
		  <!--- save last circuit --->
		  <cfset lastCircuit = circuitName>
        
        <!--- Set variables to differentiate from next circuit line --->
  			<cfset lastCircuit = circuitName>
        <cfset lastCircuitDepth = circuitDepth>
        <cfset lastCircuitPath = circuitPath>
        <!--- Clear lastFuseaction variable (circuit-specific) --->
        <cfset lastFuseaction = "">
        <cfset lastNodeType = lineType>
  		</cfcase>
  
      <!--- ************************************************************* --->
      <!---  Process a fuseaction node                                    --->
      <!--- ************************************************************* --->
  		<cfcase value="fa,defaultFa,pfa,ifa">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <!--- Check which circuit we're in for this fuseaction's level --->
        <cfset mycircuitName = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>
		  
  		  <cfset fuseactionName = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		  
		  <!--- if defaultFa, set default fuseaction --->
		  <cfif lineType eq "defaultFa">
		  	<cfset attributes.defaultFuseaction = mycircuitName & "." & fuseactionName>
		  </cfif>
		  
		  <!--- store last fuseaction --->
		  <cfset lastFuseaction = fuseactionName>
		  
		  <cfset stuFuseboxes[mycircuitName].fuseactionList = listAppend(stuFuseboxes[mycircuitName].fuseactionList,fuseActionName,"|")>
		  
		  <cfif structKeyExists(stuFuseboxes[mycircuitName].fuseactions,fuseactionName) eq false>
		  	<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName] = structNew()>
			<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].fuseList = "">
			<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].doList = "">
			<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].dos = structNew()>
			<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].fuses = structNew()>
		   <!--- if dfa, set default fuseaction --->
			<cfif lineType eq "dfa">
				<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].default = true>
			<cfelse>
				<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].default = false>
			</cfif>
		   <!--- if pfa, set access to private --->			
			<cfif lineType eq "pfa">
				<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].access = "private">
			<cfelseif lineType eq "ifa">
				<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].access = "internal">			
			<cfelse>
				<cfset stuFuseboxes[mycircuitName].fuseactions[fuseactionName].access = "">
			</cfif>			
		  </cfif>
  		</cfcase>
		
      <!--- ************************************************************* --->
      <!---  Process a fuse file node                                     --->
      <!--- ************************************************************* --->
  		<cfcase value="ff">
			<!--- used to generate XFA --->
			<cfset lastAction = "FF">		
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-2]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset fuseFile = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		 
		  <!--- store last fuse name --->
		  <cfset lastFuse = fuseFile>		  

		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuseList,fusefile) eq false>
		  		<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuseList = listAppend(stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuseList,fuseFile)>
				<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuses[fuseFile] = structNew()>
				<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuses[fuseFile].xfaList = "">
		  </cfif>
		  
		  <cfif structKeyExists(stuFuseboxes[mycircuitName].fuses,fusefile) eq false>
		  		<cfset stuFuseboxes[mycircuitName].fuses[fuseFile] = structNew()>
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].content = "">
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].contentVariable = "">
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].contentVariableAppendAttribute = "">
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].cvList = "">
		  </cfif>
  		</cfcase>
		
      <!--- ************************************************************* --->
      <!---  Process a do                                                 --->
      <!--- ************************************************************* --->
  		<cfcase value="do">
			<!--- used to generate XFA --->		
			<cfset lastAction = "DO">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-2]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset do = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		 
		  <!--- store last fuse name --->
		  <cfset lastDo = do>

		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].doList,do) eq false>
		  		<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].doList = listAppend(stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].doList,do)>
				<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[do] = structNew()>
				<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[do].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[do].contentVariable = "">
				<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[do].contentVariableAppendAttribute = "">
		  </cfif>
		  
		  <cfif structKeyExists(stuFuseboxes[mycircuitName].dos,do) eq false>
		  		<cfset stuFuseboxes[mycircuitName].dos[do] = structNew()>
				<cfset stuFuseboxes[mycircuitName].dos[do].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].dos[do].cvList = "">
		  </cfif>
  		</cfcase>
		
      <!--- ************************************************************* --->
      <!---  Process a prefa                                              --->
      <!--- ************************************************************* --->
  		<cfcase value="prefa">
			<!--- used to generate XFA --->		
			<cfset lastAction = "PREFA">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset preFa = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		 
		  <!--- store last fuse name --->
		  <cfset lastpreFa = preFa>

		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].preFuseactionList,preFa) eq false>
		  		<cfset stuFuseboxes[mycircuitName].preFuseactionList = listAppend(stuFuseboxes[mycircuitName].preFuseactionList,preFa)>
				<cfset stuFuseboxes[mycircuitName].preFuseactions[preFa] = structNew()>
				<cfset stuFuseboxes[mycircuitName].preFuseactions[preFa].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].preFuseactions[preFa].contentVariable = "">
				<cfset stuFuseboxes[mycircuitName].preFuseactions[preFa].contentVariableAppendAttribute = "">
		  </cfif>
  		</cfcase>		
		
      <!--- ************************************************************* --->
      <!---  Process a postfa                                             --->
      <!--- ************************************************************* --->
  		<cfcase value="postfa">
			<!--- used to generate XFA --->		
			<cfset lastAction = "POSTFA">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset postFa = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		 
		  <!--- store last fuse name --->
		  <cfset lastpostFa = postFa>

		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].postFuseactionList,postFa) eq false>
		  		<cfset stuFuseboxes[mycircuitName].postFuseactionList = listAppend(stuFuseboxes[mycircuitName].postFuseactionList,postFa)>
				<cfset stuFuseboxes[mycircuitName].postFuseactions[postFa] = structNew()>
				<cfset stuFuseboxes[mycircuitName].postFuseactions[postFa].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].postFuseactions[postFa].contentVariable = "">
				<cfset stuFuseboxes[mycircuitName].postFuseactions[postFa].contentVariableAppendAttribute = "">
		  </cfif>
  		</cfcase>
		
      <!--- ************************************************************* --->
      <!---  Process a globalPrefa                                        --->
      <!--- ************************************************************* --->
  		<cfcase value="globalPrefa">
			<!--- used to generate XFA --->		
			<cfset lastAction = "GLOBALPREFA">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset globalPreFa = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		 
		  <!--- store last fuse name --->
		  <cfset lastGlobalpreFa = globalPreFa>

		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].globalPreFuseactionList,globalPreFa) eq false>
		  		<cfset stuFuseboxes[mycircuitName].globalPreFuseactionList = listAppend(stuFuseboxes[mycircuitName].globalPreFuseactionList,globalPreFa)>
				<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[globalPreFa] = structNew()>
				<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[globalPreFa].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[globalPreFa].contentVariable = "">
				<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[globalPreFa].contentVariableAppendAttribute = "">
		  </cfif>
  		</cfcase>		
		
      <!--- ************************************************************* --->
      <!---  Process a globalPostfa                                       --->
      <!--- ************************************************************* --->
  		<cfcase value="globalPostfa">
			<!--- used to generate XFA --->		
			<cfset lastAction = "GLOBALPOSTFA">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset globalPostFa = "#Trim(ListLast(aryOutline[lineNum],":"))#">
		 
		  <!--- store last fuse name --->
		  <cfset lastglobalPostFa = globalPostFa>

		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].globalPostFuseactionList,globalPostFa) eq false>
		  		<cfset stuFuseboxes[mycircuitName].globalPostFuseactionList = listAppend(stuFuseboxes[mycircuitName].globalPostFuseactionList,globalPostFa)>
				<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[globalPostFa] = structNew()>
				<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[globalPostFa].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[globalPostFa].contentVariable = "">
				<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[globalPostFa].contentVariableAppendAttribute = "">				
		  </cfif>
  		</cfcase>		
		
      <!--- ************************************************************* --->
      <!---  Process a content variable                                   --->
      <!--- ************************************************************* --->
  		<cfcase value="cv,cva,cvo">

			<!--- extract cv information --->
			<cfset cv = "#Trim(ListLast(aryOutline[lineNum],":"))#">
	  		<cfset cvName = "#listFirst(cv,"=")#">
			
			<cfif lineType eq "cva">
				<cfset cvAppendAttribute = "true">
			<cfelseif lineType eq "cvo">
				<cfset cvAppendAttribute = "false">
			<cfelse>
				<cfset cvAppendAttribute = "">
			</cfif>
			
			<cfif lastAction eq "FF">	
				<cfif structKeyExists(stuFuseboxes[mycircuitName].fuses,lastFuse) eq true>
					<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuses[lastFuse].contentVariable = cv>
					<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuses[lastFuse].contentVariableAppendAttribute = cvAppendAttribute>
				</cfif>
						
				<cfif structKeyExists(stuFuseboxes[mycircuitName].fuses,lastFuse) and listFindNoCase(stuFuseboxes[mycircuitName].fuses[lastFuse].cvList,cvName) eq 0>
					<cfset stuFuseboxes[mycircuitName].fuses[lastFuse].cvList = listAppend(stuFuseboxes[mycircuitName].fuses[lastFuse].cvList,cv)>
				</cfif>
			<cfelseif lastAction eq "PREFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].preFuseactions,lastpreFa) eq true>
					<cfset stuFuseboxes[mycircuitName].preFuseactions[lastpreFa].contentVariable = cv>
					<cfset stuFuseboxes[mycircuitName].preFuseactions[lastpreFa].contentVariableAppendAttribute = cvAppendAttribute>
					
				</cfif>
			<cfelseif lastAction eq "POSTFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].postFuseactions,lastpostFa) eq true>
					<cfset stuFuseboxes[mycircuitName].postFuseactions[lastpostFa].contentVariable = cv>
					<cfset stuFuseboxes[mycircuitName].postFuseactions[lastpostFa].contentVariableAppendAttribute = cvAppendAttribute>
				</cfif>
			<cfelseif lastAction eq "GLOBALPREFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].globalPreFuseactions,lastglobalPreFa) eq true>
					<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[lastglobalPreFa].contentVariable = cv>
					<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[lastglobalPreFa].contentVariableAppendAttribute = cvAppendAttribute>
				</cfif>
			<cfelseif lastAction eq "GLOBALPOSTFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].globalPostFuseactions,lastglobalPostFa) eq true>
					<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[lastglobalPostFa].contentVariable = cv>
					<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[lastglobalPostFa].contentVariableAppendAttribute = cvAppendAttribute>
				</cfif>							
			<cfelse>
				<cfif structKeyExists(stuFuseboxes[mycircuitName].fuseactions,lastFuseaction) eq true>
					<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[lastDo].contentVariable = cv>
					<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[lastDo].contentVariableAppendAttribute = cvAppendAttribute>					
				</cfif>

				<cfif structKeyExists(stuFuseboxes[mycircuitName].dos,lastdo) and listFindNoCase(stuFuseboxes[mycircuitName].dos[lastdo].cvList,cvName) eq 0>
					<cfset stuFuseboxes[mycircuitName].dos[lastdo].cvList = listAppend(stuFuseboxes[mycircuitName].dos[lastdo].cvList,cv)>
				</cfif>			
			</cfif>
  		</cfcase>		

      <!--- ************************************************************* --->
      <!---  Process an xfa node                                          --->
      <!--- ************************************************************* --->
		<cfcase value="xf,xfa">
		
			<!--- extract xfa information --->
			<cfset xfa = "#Trim(ListLast(aryOutline[lineNum],":"))#">
	  		<cfset xfaName = "#listFirst(xfa,"=")#">
			<cfset xfaValue = "#ListLast(xfa,"=")#">
			
			<cfif isDefined("lastAction") and lastAction eq "DO">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].dos,lastdo) eq true>
					<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[lastdo].xfaList = listAppend(stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].dos[lastdo].xfaList,xfa)>
				</cfif>
						
				<cfif structKeyExists(stuFuseboxes[mycircuitName].dos,lastdo) and listFindNoCase(stuFuseboxes[mycircuitName].dos[lastdo].xfaList,xfaName) eq 0>
					<cfset stuFuseboxes[mycircuitName].dos[lastdo].xfaList = listAppend(stuFuseboxes[mycircuitName].dos[lastdo].xfaList,xfaName)>
				</cfif>
			<cfelseif isDefined("lastAction") and lastAction eq "PREFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].preFuseactions,lastPreFa) and listFindNoCase(stuFuseboxes[mycircuitName].preFuseactions[lastPreFa].xfaList,xfa) eq 0>
					<cfset stuFuseboxes[mycircuitName].preFuseactions[lastPreFa].xfaList = listAppend(stuFuseboxes[mycircuitName].preFuseactions[lastPreFa].xfaList,xfa)>
				</cfif>			
			<cfelseif isDefined("lastAction") and lastAction eq "POSTFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].postFuseactions,lastPostFa) and listFindNoCase(stuFuseboxes[mycircuitName].postFuseactions[lastPostFa].xfaList,xfa) eq 0>
					<cfset stuFuseboxes[mycircuitName].postFuseactions[lastPostFa].xfaList = listAppend(stuFuseboxes[mycircuitName].postFuseactions[lastPostFa].xfaList,xfa)>
				</cfif>
			<cfelseif isDefined("lastAction") and lastAction eq "GLOBALPREFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].globalPreFuseactions,lastglobalPreFa) and listFindNoCase(stuFuseboxes[mycircuitName].globalPreFuseactions[lastglobalPreFa].xfaList,xfa) eq 0>
					<cfset stuFuseboxes[mycircuitName].globalPreFuseactions[lastglobalPreFa].xfaList = listAppend(stuFuseboxes[mycircuitName].globalPreFuseactions[lastglobalPreFa].xfaList,xfa)>
				</cfif>			
			<cfelseif isDefined("lastAction") and lastAction eq "GLOBALPOSTFA">
				<cfif structKeyExists(stuFuseboxes[mycircuitName].globalPostFuseactions,lastglobalPostFa) and listFindNoCase(stuFuseboxes[mycircuitName].globalPostFuseactions[lastglobalPostFa].xfaList,xfa) eq 0>
					<cfset stuFuseboxes[mycircuitName].globalPostFuseactions[lastglobalPostFa].xfaList = listAppend(stuFuseboxes[mycircuitName].globalPostFuseactions[lastglobalPostFa].xfaList,xfa)>
				</cfif>				
			<cfelse>
				<cfif structKeyExists(stuFuseboxes[mycircuitName].fuseactions,lastFuseaction) eq true>
					<cfset stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuses[lastFuse].xfaList = listAppend(stuFuseboxes[mycircuitName].fuseactions[lastFuseaction].fuses[lastFuse].xfaList,xfa)>			
				</cfif>
				
				<cfif listFindNoCase(stuFuseboxes[mycircuitName].directFiles.fuseList,lastFuse) neq 0>
					<cfset stuFuseboxes[mycircuitName].directFiles.xfaList = listAppend(stuFuseboxes[mycircuitName].directFiles.xfaList,xfa)>
				</cfif>
	
				<cfif listFindNoCase(stuFuseboxes[mycircuitName].layouts.fuseList,lastFuse) neq 0>
					<cfset stuFuseboxes[mycircuitName].layouts.xfaList = listAppend(stuFuseboxes[mycircuitName].layouts.xfaList,xfa)>
				</cfif>
				
				<cfif structKeyExists(stuFuseboxes[mycircuitName].fuses,lastFuse) and listFindNoCase(stuFuseboxes[mycircuitName].fuses[lastFuse].xfaList,xfaName) eq 0>
					<cfset stuFuseboxes[mycircuitName].fuses[lastFuse].xfaList = listAppend(stuFuseboxes[mycircuitName].fuses[lastFuse].xfaList,xfaName)>
				</cfif>
			</cfif>
      </cfcase>

      <!--- ************************************************************* --->
      <!---  Process a direct file node                                  --->
      <!--- ************************************************************* --->
      <cfcase value="df">
        <!--- Get line's depth by finding first non-space character in line. --->
        <cfset lineDepth = (REFind("[^#attributes.indenter#]",aryOutline[lineNum])-1)/Len(attributes.indenter)+1>
        <cfset mycircuitName = aryInCircuit[lineDepth-1]>
        <cfset myCircuitPath = stuFuseboxes[mycircuitName].path>

  		  <cfset fuseFile = "#Trim(ListLast(aryOutline[lineNum],":"))#">

		  <!--- store last fuse name --->
		  <cfset lastFuse = fuseFile>
		  
		  <cfif listFindNoCase(stuFuseboxes[mycircuitName].directFiles.fuseList,fuseFile) eq 0>
		  		<cfset stuFuseboxes[mycircuitName].directFiles.fuseList = listAppend(stuFuseboxes[mycircuitName].directFiles.fuseList,fuseFile)>
		  </cfif>		  
		  
		  <cfif structKeyExists(stuFuseboxes[mycircuitName].fuses,fusefile) eq false>
		  		<cfset stuFuseboxes[mycircuitName].fuses[fuseFile] = structNew()>
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].xfaList = "">
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].content = "">
				<cfset stuFuseboxes[mycircuitName].fuses[fuseFile].cvList = "">				
		  </cfif>		  
      </cfcase>
		
  		<cfdefaultcase>
 		  <cfif lineType neq "">
		  		Unknown Prefix: <cfoutput>'#lineType#' on line #lineNum#.</cfoutput><br>
		  <cfelse>
	        <!--- Peel indenters off line --->
	        <cfif len(attributes.indenter) EQ 1>
	          <cfset leftJustLine = listFirst(aryOutline[lineNum],attributes.indenter)>
	        <cfelse>
	          <cfset leftJustLine = aryOutline[lineNum]>
	          <cfset leftJustLine = Right(leftJustLine,len(leftJustLine)-(len(attributes.indenter)*lineDepth))>
	        </cfif>
			 
			  <!--- append content --->
			  <cfif structKeyExists(stuFuseboxes[lastCircuit].fuses,lastFuse)>
				  <cfset stuFuseboxes[lastCircuit].fuses[lastFuse].content = stuFuseboxes[lastCircuit].fuses[lastFuse].content & leftJustLine & crlf>
			  <cfelse>
			  	  <cfoutput>Line #lineNum#: Could not append content '<b>#trim(leftJustLine)#</b>' to '<b>#lastFuse#</b>' in the '<b>#lastCircuit#</b>' circuit.<br></cfoutput>
			  </cfif>
		  </cfif>		  
  		</cfdefaultcase>
  	</cfswitch>
  </cfif>
</cfloop>
<cfcatch>
	<cfif variables.build_error_count eq 0><h3>An Error Occurred!</h3></cfif>
	<cfoutput><b>Problem with line #lineNum#:</b> - #aryOutline[lineNum]#</cfoutput><br>
	<cfset variables.build_error_count = variables.build_error_count + 1>
</cfcatch>
</cftry>

<cfif variables.build_error_count neq 0><hr></cfif>

<!--- Output start of process message --->
 <cfoutput>
 <span class="header">
 FuseMinderFB4 v 1.02 by Jeff Peters &lt;jeff@grokfusebox.com&gt; and Jamie Thomas &lt;jamie.thomas@integic.com&gt;<br>
 </span>
 -- <strong>Run date:</strong> #Dateformat(Now())#, #TimeFormat(Now())# -- <strong>Outline File:</strong> #attributes.OutlineFile#
 </span>
 </cfoutput>
 <hr>

<!--- append map name to location --->

<cfset attributes.location = attributes.location & listFirst(attributes.OutlineFile,".") & "\">

<!--- delete all subdirectories first --->
<cf_directory_delete directory="#attributes.location#">

<!--- create directory --->
<cftry>
<cfdirectory action="create" directory="#attributes.location#">
	<cfcatch type="Any">
	</cfcatch>
</cftry>

<!--- loop circuits and build files --->
<cfloop list="#circuitList#" index="c">

	<!--- copy circuit structure locally --->
	<cfset stuCircuit = duplicate(stuFuseboxes[c])>
	
	<!--- set class and indent --->
	<cfset class = "bg#stuCircuit.depth#">
	<cfset spacer = repeatString("&nbsp;&nbsp;",stuCircuit.depth)>

	<!--- create directory --->
	<cftry>
	<cfdirectory action="create" directory="#attributes.location##stuCircuit.path#">
		<cfcatch type="Any">
		</cfcatch>
	</cftry>	
	
	<!--- clear out directory --->
	<cftry>
	<cfdirectory action="list" directory="#attributes.location##stuCircuit.path#" name="qry_files">
	<cfloop query="qry_files">
		<cfif type eq "file">
			<cffile action="DELETE" file="#attributes.location##stuCircuit.path#\#name#">
		</cfif>
	</cfloop>
		<cfcatch type="Any">
		</cfcatch>
	</cftry>	
	
	<!--- create parsed and plugins directory directory --->
	<cfif c eq listFirst(circuitList)>
	<cftry>
	<cfdirectory action="create" directory="#attributes.location##stuCircuit.path#\parsed">
		<cfcatch type="Any">
		</cfcatch>
	</cftry>
	<cftry>
	<cfdirectory action="create" directory="#attributes.location##stuCircuit.path#\plugins">
		<cfcatch type="Any">
		</cfcatch>
	</cftry>			
	</cfif>

	<cfif attributes.verbose EQ "Yes">
		<cfoutput>
		<span class="#class#">
		<cfif stuFuseboxes[c].alias neq c>
			<strong>#spacer#Building #uCase(c)# (#stuFuseboxes[c].alias#) circuit [#uCase(stuFuseboxes[c].access)#].</strong><br>		
		<cfelse>
			<strong>#spacer#Building #uCase(c)# circuit [#uCase(stuFuseboxes[c].access)#].</strong><br>
		</cfif>
		</span>
		</cfoutput>
	</cfif>

	<!--- If in main circuit, create fusebox.xml.cfm file and write opening lines --->
	<cfif stuCircuit.depth EQ 1>
		<cfset fuseboxXMLFile = "#attributes.location##stuCircuit.path#fusebox.xml.cfm">
		<!--- Write standard lines to circuits file. --->
		<cffile action="WRITE" file="#fuseboxXMLFile#" output="#fbOpenFuseboxXML#">
		<cffile action="APPEND" file="#fuseboxXMLFile#" output="	<circuits>">
		<cfloop list="#circuitList#" index="c2">
			<cfset path = stuFuseboxes[c2].path>
			<cfset path = replaceNoCase(path,"\","/","all")>
			<cfif left(path,1) eq "/">
				<cfset path = right(path,len(path)-1)>
			</cfif>
			
			<cfset usePath = listRest(path,"/")>
			
			<cfif listLen(path,"/") gt 1>
				<cfset parent = listGetAt(path,listLen(path,"/")-1,"/")>
				<cfset parent = stuFuseboxes[parent].alias>
			<cfelse>
				<cfset parent = "">
			</cfif>
			
			<cfset alias = stuFuseboxes[c2].alias>
			<cffile action="APPEND" file="#fuseboxXMLFile#" output="		<circuit alias=""#alias#"" path=""#usePath#"" parent=""#parent#"" />">
			
		</cfloop>
		<cffile action="APPEND" file="#fuseboxXMLFile#" output="	</circuits>#crlf#">
		<cffile action="APPEND" file="#fuseboxXMLFile#" output="#fbCloseFuseboxXML(stuCircuit)#">		
		
		<cfif attributes.verbose EQ "Yes">
			<cfoutput>
			<span class="#class#">
			#spacer#fusebox.xml.cfm for #c# circuit written.<br>
			</span>
			</cfoutput>
		</cfif>
	</cfif>
 
	<!--- Create circuit.xml for circuit --->
	<cfset circuitXMLFile = "#attributes.location##stuCircuit.path#circuit.xml.cfm">
	
	<!--- Write note line (first line of file) to circuit.xml file --->
	<cffile action="WRITE" mode="#modeEverybodyReadWrite#" file="#circuitXMLFile#"
		output="#fbOpenCircuitXML(stuCircuit)#">

	<cfif attributes.verbose EQ "Yes">
		<cfoutput>
		<span class="#class#">
		#spacer#circuit.xml.cfm for #c# circuit written.<br>
		</span>
		</cfoutput>
		<cfflush>
	</cfif>
	
	<!--- loop and build fuseactions --->
	<cfloop list="#stuCircuit.fuseActionList#" index="iFuseaction" delimiters="|">

		<!--- open fuseaction statement --->
		
		<cfset openFuseaction = crlf & "	<fuseaction name=""#iFuseAction#""">
		<cfif stuCircuit.fuseactions[iFuseaction].access neq "">
			<cfset openFuseaction = openFuseaction & " access=""#stuCircuit.fuseactions[iFuseaction].access#""">
		</cfif>		
		<cfset openFuseaction = openFuseaction & ">">
	
		<cffile action="APPEND" file="#circuitXMLFile#" output="#openFuseaction#">
		
		<cfif attributes.verbose EQ "Yes">
			<cfoutput>
			<span class="#class#">
			#repeatString(spacer,2)# <cfif stuCircuit.fuseactions[iFuseaction].default><b>(DEFAULT)</b></cfif> Fuseaction '#iFuseAction#' written <cfif stuCircuit.fuseactions[iFuseaction].access neq ""><b>[#uCase(stuCircuit.fuseactions[iFuseaction].access)#]</b></cfif>.<br>
			</span>
			</cfoutput>
			<cfflush>
		</cfif>
		
		<!--- loop and include dos --->
		
		<cfloop list="#stuCircuit.fuseactions[iFuseaction].doList#" index="iDo">
		
			<!--- get xfas --->
			<cfif listLen(stuCircuit.fuseactions[iFuseaction].dos[iDo].xfaList) neq 0>
				<cfloop list="#stuCircuit.fuseactions[iFuseaction].dos[iDo].xfaList#" index="iXFA">
					<cffile action="APPEND" file="#circuitXMLFile#" output="		<xfa name=""#listFirst(iXFA,"=")#"" value= ""#ListLast(iXFA,"=")#"" />">

					<cfif attributes.verbose EQ "Yes">
						<cfoutput>
						<span class="#class#">
						#repeatString(spacer,3)#XFA '#listFirst(iXFA,"=")#' written.<br>
						</span>
						<cfflush>
						</cfoutput>
					</cfif>
				</cfloop>
			</cfif>		
		
			<!--- build friendly name for do --->

			<cfif listFirst(iDo,".") eq c>
				<cfset useDo = listLast(iDo,".")>
			<cfelse>
				<cfset useDo = iDo>
			</cfif>
			
			<cfif stuCircuit.fuseactions[iFuseaction].dos[iDo].contentVariable neq "">
				<cfif stuCircuit.fuseactions[iFuseaction].dos[iDo].contentVariableAppendAttribute neq "">
					<cffile action="APPEND" file="#circuitXMLFile#" output="		<do action=""#useDo#"" contentvariable=""#stuCircuit.fuseactions[iFuseaction].dos[iDo].contentVariable#"" append=""#stuCircuit.fuseactions[iFuseaction].dos[iDo].contentVariableAppendAttribute#"" />">
				<cfelse>
					<cffile action="APPEND" file="#circuitXMLFile#" output="		<do action=""#useDo#"" contentvariable=""#stuCircuit.fuseactions[iFuseaction].dos[iDo].contentVariable#"" />">					
				</cfif>
			<cfelse>
				<cffile action="APPEND" file="#circuitXMLFile#" output="		<do action=""#useDo#"" />">
			</cfif>
			
			<cfif attributes.verbose EQ "Yes">
				<cfoutput>
				<span class="#class#">
				#repeatString(spacer,3)#Do '#iDo#' written.<br>
				</span>
				</cfoutput>
				<cfflush>
			</cfif>						
			
		</cfloop>
		
		<!--- loop and include fuses --->
		
		<cfloop list="#stuCircuit.fuseactions[iFuseaction].fuseList#" index="iFuse">

			<!--- get xfas --->
			<cfif listLen(stuCircuit.fuseactions[iFuseaction].fuses[iFuse].xfaList) neq 0>
				<cfloop list="#stuCircuit.fuseactions[iFuseaction].fuses[iFuse].xfaList#" index="iXFA">
					<cffile action="APPEND" file="#circuitXMLFile#" output="		<xfa name=""#listFirst(iXFA,"=")#"" value= ""#ListLast(iXFA,"=")#"" />">

					<cfif attributes.verbose EQ "Yes">
						<cfoutput>
						<span class="#class#">
						#repeatString(spacer,3)#XFA '#listFirst(iXFA,"=")#' written.<br>
						</span>
						<cfflush>
						</cfoutput>
					</cfif>
				</cfloop>
			</cfif>
			
			<cfif listLast(iFuse,".") eq "cfc">
				<cffile action="APPEND" file="#circuitXMLFile#" output="		<!-- <set name=""a_#listFirst(iFuse,".")#"" value=""##createObject('component','#listFirst(iFuse,".")#')##"" /> -->">
			<cfelse>
				<cffile action="APPEND" file="#circuitXMLFile#" output="		<include template=""#listFirst(iFuse,".")#"" />">
			</cfif>
			
			<cfif attributes.verbose EQ "Yes">
				<cfoutput>
				<span class="#class#">
				#repeatString(spacer,3)#Fuse '#iFuse#' included.<br>
				</span>
				</cfoutput>
				<cfflush>
			</cfif>			
			
			<!--- look up xfas --->
			<cfif isDefined("iFuseaction") eq true>
				<cfset void = xfaLookup(stuCircuit, iFuseaction, iFuse)>
			</cfif>
			
		</cfloop>
		
		<cffile action="APPEND" file="#circuitXMLFile#" output="	</fuseaction>">
		
	</cfloop>

	<cffile action="APPEND" file="#circuitXMLFile#" output="#fbCloseCircuitXML(stuCircuit)#">	
	
	<!--- loop and build fuses --->
	<cfloop list="#structKeyList(stuCircuit.fuses)#" index="iFuse">

		<!--- create file --->
		<cffile action="WRITE" mode="#modeEverybodyReadWrite#" file="#attributes.location##stuCircuit.path##iFuse#"
				output="#fuseStubCreate(iFuse,stuCircuit.fuses[iFuse].xfaList,stuCircuit.fuses[iFuse].cvList,attributes.writeFusedocs,attributes.writeFileName,attributes.writeXFALinks)##trim(stripCR(stuCircuit.fuses[iFuse].content))#">		
		
		<cfif attributes.verbose EQ "Yes">
			<cfoutput>
			<span class="#class#">
			#repeatString(spacer,2)#Fuse '#iFuse#' written.<br>
			</span>
			<cfflush>
			</cfoutput>
		</cfif>	
	</cfloop>
	
</cfloop>

<!--- copy core files to root directory --->

<cfset class = "bg0">
<cfdirectory directory="#attributes.core_file_location#" name="qry_core_files" filter="*.cfm">
<cfif attributes.verbose EQ "Yes">
	<cfoutput>
	<span class="#class#">
	<b>Copying Core Files.</b><br>
	</span>
	<cfflush>
	</cfoutput>
</cfif>
<cfloop query="qry_core_files">
	<cfset copy_result = "'#name#' copied to #listFirst(circuitList)# circuit.">
	<cffile action="COPY" source="#attributes.core_file_location##name#" destination="#attributes.location##stuFuseboxes[listFirst(circuitList)].path##name#">
	
	<cfif attributes.verbose EQ "Yes">
		<cfoutput>
		<span class="#class#">
		#copy_result#<br>
		</span>
		<cfflush>
		</cfoutput>
	</cfif>
</cfloop>

<!--- if no core files, display a message --->

<cfif qry_core_files.recordCount eq 0>
<cfif attributes.verbose EQ "Yes">
	<cfoutput>
	<span class="#class#">
	<b>NO core files to copy.</b><br>
	</span>
	<cfflush>
	</cfoutput>
</cfif>
</cfif>

<!--- display a link to the application --->

<br><br>
<cfoutput>
<b><a href="#listFirst(attributes.outlineFile,".")#/#stuFuseboxes[listFirst(circuitList)].path#">You can browse the generated code here</a>.</b>
</cfoutput>
<br><br>

<!-- Output end of process message --->
<cfif attributes.verbose EQ "Yes">
  <span class="header">
  Application build complete.<br>
  </span>
  <hr>
  &copy; Jeffrey S. Peters 2000-<cfoutput>#year(now())#</cfoutput> All Rights Reserved
</cfif>

<!--- <cfdump var="#stuFuseboxes#"> --->